package com.eactive.eai.agent.authserver;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.authserver.service.OAuth2Manager;
import com.eactive.eai.common.util.Logger;

@SuppressWarnings("serial")
public class ReloadClientCommand extends Command {

	public ReloadClientCommand() {
		super("ReloadClientCommand");
	}

	@Override
	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			OAuth2Manager manager = OAuth2Manager.getInstance();

			String keyName = (String) args;

			if (keyName != null) {
				manager.reloadClient(keyName);
				if (logger.isWarn()) {
					logger.warn(this.name + "] " + keyName + " Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";
	}
}